import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 外委申请服务对象基类
 *
 * @export
 * @class EMApplyServiceBase
 * @extends {EntityServie}
 */
export default class EMApplyServiceBase extends EntityService {

    /**
     * Creates an instance of  EMApplyServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  EMApplyServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof EMApplyServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='emapply';
        this.APPDEKEY = 'emapplyid';
        this.APPDENAME = 'emapplies';
        this.APPDETEXT = 'emapplyname';
        this.APPNAME = 'eamweb';
        this.SYSTEMNAME = 'eam_practice02';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMApplyServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emapply){
            return Http.getInstance().get(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emapplies/${context.emapply}/select`,isloading);
        }
        if(context.emeqtype && context.emequip && context.emapply){
            return Http.getInstance().get(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emapplies/${context.emapply}/select`,isloading);
        }
        if(context.emequip && context.emapply){
            return Http.getInstance().get(`/emequips/${context.emequip}/emapplies/${context.emapply}/select`,isloading);
        }
            return Http.getInstance().get(`/emapplies/${context.emapply}/select`,isloading);
    }

    /**
     * Remove接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMApplyServiceBase
     */
    public async Remove(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emapply){
            return Http.getInstance().delete(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emapplies/${context.emapply}`,isloading);
        }
        if(context.emeqtype && context.emequip && context.emapply){
            return Http.getInstance().delete(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emapplies/${context.emapply}`,isloading);
        }
        if(context.emequip && context.emapply){
            return Http.getInstance().delete(`/emequips/${context.emequip}/emapplies/${context.emapply}`,isloading);
        }
            return Http.getInstance().delete(`/emapplies/${context.emapply}`,isloading);

    }

    /**
     * Update接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMApplyServiceBase
     */
    public async Update(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emapply){
            return Http.getInstance().put(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emapplies/${context.emapply}`,data,isloading);
        }
        if(context.emeqtype && context.emequip && context.emapply){
            return Http.getInstance().put(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emapplies/${context.emapply}`,data,isloading);
        }
        if(context.emequip && context.emapply){
            return Http.getInstance().put(`/emequips/${context.emequip}/emapplies/${context.emapply}`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().put(`/emapplies/${context.emapply}`,data,isloading);
            return res;
    }

    /**
     * CheckKey接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMApplyServiceBase
     */
    public async CheckKey(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emapply){
            return Http.getInstance().post(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emapplies/${context.emapply}/checkkey`,data,isloading);
        }
        if(context.emeqtype && context.emequip && context.emapply){
            return Http.getInstance().post(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emapplies/${context.emapply}/checkkey`,data,isloading);
        }
        if(context.emequip && context.emapply){
            return Http.getInstance().post(`/emequips/${context.emequip}/emapplies/${context.emapply}/checkkey`,data,isloading);
        }
            return Http.getInstance().post(`/emapplies/${context.emapply}/checkkey`,data,isloading);
    }

    /**
     * Save接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMApplyServiceBase
     */
    public async Save(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emapply){
            return Http.getInstance().post(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emapplies/${context.emapply}/save`,data,isloading);
        }
        if(context.emeqtype && context.emequip && context.emapply){
            return Http.getInstance().post(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emapplies/${context.emapply}/save`,data,isloading);
        }
        if(context.emequip && context.emapply){
            return Http.getInstance().post(`/emequips/${context.emequip}/emapplies/${context.emapply}/save`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().post(`/emapplies/${context.emapply}/save`,data,isloading);
            return res;
    }

    /**
     * GetDraft接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMApplyServiceBase
     */
    public async GetDraft(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && true){
            return Http.getInstance().get(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emapplies/getdraft`,isloading);
        }
        if(context.emeqtype && context.emequip && true){
            return Http.getInstance().get(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emapplies/getdraft`,isloading);
        }
        if(context.emequip && true){
            return Http.getInstance().get(`/emequips/${context.emequip}/emapplies/getdraft`,isloading);
        }
        let res:any = await  Http.getInstance().get(`/emapplies/getdraft`,isloading);
        res.data.emapply = data.emapply;
        return res;
    }

    /**
     * Create接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMApplyServiceBase
     */
    public async Create(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emapplies`,data,isloading);
        }
        if(context.emeqtype && context.emequip && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emapplies`,data,isloading);
        }
        if(context.emequip && true){
            if(!data.srffrontuf || data.srffrontuf !== "1"){
                data[this.APPDEKEY] = null;
            }
            if(data.srffrontuf){
                delete data.srffrontuf;
            }
            return Http.getInstance().post(`/emequips/${context.emequip}/emapplies`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
        if(!data.srffrontuf || data.srffrontuf !== "1"){
            data[this.APPDEKEY] = null;
        }
        if(data.srffrontuf){
            delete data.srffrontuf;
        }
        let tempContext:any = JSON.parse(JSON.stringify(context));
        let res:any = await Http.getInstance().post(`/emapplies`,data,isloading);
        return res;
    }

    /**
     * Get接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMApplyServiceBase
     */
    public async Get(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && context.emapply){
            return Http.getInstance().get(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emapplies/${context.emapply}`,isloading);
        }
        if(context.emeqtype && context.emequip && context.emapply){
            return Http.getInstance().get(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emapplies/${context.emapply}`,isloading);
        }
        if(context.emequip && context.emapply){
            return Http.getInstance().get(`/emequips/${context.emequip}/emapplies/${context.emapply}`,isloading);
        }
            let res:any = await Http.getInstance().get(`/emapplies/${context.emapply}`,isloading);
            return res;

    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof EMApplyServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pfteam && context.emequip && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/pfteams/${context.pfteam}/emequips/${context.emequip}/emapplies/fetchdefault`,tempData,isloading);
        }
        if(context.emeqtype && context.emequip && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emeqtypes/${context.emeqtype}/emequips/${context.emequip}/emapplies/fetchdefault`,tempData,isloading);
        }
        if(context.emequip && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/emequips/${context.emequip}/emapplies/fetchdefault`,tempData,isloading);
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        return Http.getInstance().get(`/emapplies/fetchdefault`,tempData,isloading);
    }
}